
package de.ivu.elect.dokumente.ergebnis;

import java.util.Collection;

import de.ivu.elect.business.security.Customer;
import de.ivu.elect.business.stimmeingabe.entity.Ergebniseingabestatus;
import de.ivu.elect.business.wahl.control.AbstractNlExportArtefaktNachSystemExportstatusExportContext;
import de.ivu.elect.business.wahl.entity.NlWahlart;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.was.exchange.ergebnis.NlWasModelNa311ExportMapper;
import de.ivu.elect.was.exchange.ergebnis.NlWasModelNa311ExportMapperHelper;

/**
 * Ist das Gegenstück zu Model Na 31-2 (ehemals Model II) bei DEZENTRALER Erfassung.
 *
 * @see NlWasModelNa311Eml510bExportMapper
 * @see NlWasModelNa311Eml510dExportMapper
 * @see NlWasModelNa311Osv43CsvExportMapper
 */
public class NlWasModelNa311MainDocumentExportMapper extends AbstractNlWasGesamtErgebnisDokumentNachGebietErgebniseingabestatusDocumentExportMapper implements NlWasModelNa311ExportMapper {

  public static final String FILE_FORMAT_NAME = "file.format.ergebnisdokument.export.modelna311.main";

  public NlWasModelNa311MainDocumentExportMapper() {
    super();
  }

  @Override
  protected boolean isAcceptWahlebene(Wahl wahl, Customer customer) {
    return NlWasModelNa311ExportMapperHelper.isAcceptWahlebene(wahl, customer);
  }

  @Override
  protected Collection<NlWahlart> collectWahlartenAccepted() {
    return NlWasModelNa311ExportMapperHelper.collectWahlartenAccepted();
  }

  @Override
  protected boolean isAcceptWahlergebniserfassung(Wahl wahl, Customer customer) {
    return NlWasModelNa311ExportMapperHelper.isAcceptWahlergebniserfassung(wahl, customer);
  }

  @Override
  protected Collection<Ergebniseingabestatus> collectErgebniseingabestatusAccepted() {
    return NlWasModelNa311ExportMapperHelper.collectErgebniseingabestatusAccepted();
  }

  @Override
  public String getFileFormatName() {
    return FILE_FORMAT_NAME;
  }

  @Override
  protected String getDokumentVorlageNameInfix() {
    return "Model Na 31-1";
  }

  /*
   * https://support.elect-it.com/wiki/x/XoE8
   */

  @Override
  public boolean requiresWahlbehoerdeWahlleiterName(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresWahlbehoerdeAnschriftStrasseHausnummer(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresWahlbehoerdeAnschriftOrt(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresWahlbehoerdeAnschriftPlz(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresWahlbehoerdeDokumentErstelltAnschriftStrasseHausnummer(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresWahlbehoerdeDokumentErstelltAnschriftOrt(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresWahlbehoerdeDokumentErstelltAnschriftPlz(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresWahlbehoerdeDokumentErstelltAm(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresGewaehltesGremiumAnschriftStrasseHausnummer(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresGewaehltesGremiumAnschriftOrt(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresGewaehltesGremiumAnschriftPlz(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresWahlausschusssitzungAnschriftStrasseHausnummer(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresWahlausschusssitzungAnschriftOrt(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresWahlausschusssitzungAnschriftPlz(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresWahlausschusssitzungBeginn(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresWahlausschusssitzungEnde(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresWahlausschusssitzungEinwaende(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresWahlausschusssitzungEinwaendeBemerkungen(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return false;
  }

  @Override
  public boolean requiresKorrekturenErfassungsgebiete(AbstractNlExportArtefaktNachSystemExportstatusExportContext context) {
    return true; // ELECT-15560
  }
}
